/** \file
	Program szyfrujco - deszyfrujcy (algorytm symetryczny) dla plikw binarnych
*/

#include <vcl.h>
#include <stdio.h>
#include <stdlib.h>
#pragma hdrstop

#include "mainUnit.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "CGAUGES"
#pragma resource "*.dfm"
TfrmMain *frmMain;
unsigned int lSize = 0;							///< rozmiar pliku wczytanego/wyjciowego
#define PASSWORD "4f!  f45GF_ _1113,. ,*-   *+6 4   56FJ K"	///< haso szyfrujce


//---------------------------------------------------------------------------
__fastcall TfrmMain::TfrmMain(TComponent* Owner)
	: TForm(Owner)
{
}



/**
    Crypt routine is taken from article
    http://www.codeproject.com/KB/security/crypt_routine.aspx?fid=4418&df=90&mpp=25&noise=3&sort=Position&view=Quick&select=943809&fr=1
    by Shrishail Rana. It may contain some nonsignificant modifications and has some ugly VCL progress bar update added.
    
    This Crypt routine uses an algorithm created by Rodney Thayer.
    This algorithm can use keys of various sizes.
    With a 40-bit key (5 characters) it can be freely exported from the U.S.
    The cipher is considered robust with 128 bits of key material but can use up to 2048 bits.
    It is compatible with RSAs RC4 algorithm.
*/
void Crypt(char *inp, DWORD inplen, char* key)
{
    //we will consider size of sbox 256 bytes
    //(extra byte are only to prevent any mishep just in case)
    char Sbox[257], Sbox2[257];
    unsigned long i, j, t, x;

    char temp , k;
    i = j = k = t =  x = 0;
    temp = 0;

    //always initialize the arrays with zero
    ZeroMemory(Sbox, sizeof(Sbox));
    ZeroMemory(Sbox2, sizeof(Sbox2));

    //initialize sbox i
    for(i = 0; i < 256U; i++)
    {
        Sbox[i] = (char)i;
    }

    j = 0;

    //initialize the sbox2 with user key
    for(i = 0; i < 256U ; i++)
    {
        if(j == strlen(key))
        {
            j = 0;
        }
        Sbox2[i] = key[j++];
    }


    j = 0 ; //Initialize j
    //scramble sbox1 with sbox2
    for(i = 0; i < 256; i++)
    {
        j = (j + (unsigned long) Sbox[i] + (unsigned long) Sbox2[i]) % 256U ;
        temp =  Sbox[i];
        Sbox[i] = Sbox[j];
        Sbox[j] =  temp;
    }

    i = j = 0;
    for(x = 0; x < inplen; x++)
    {
        //increment i
        i = (i + 1U) % 256U;
        //increment j
        j = (j + (unsigned long) Sbox[i]) % 256U;

        //Scramble SBox #1 further so encryption routine will
        //will repeat itself at great interval
        temp = Sbox[i];
        Sbox[i] = Sbox[j] ;
        Sbox[j] = temp;

        //Get ready to create pseudo random  byte for encryption key
        t = ((unsigned long) Sbox[i] + (unsigned long) Sbox[j]) %  256U ;

        //get the random byte
        k = Sbox[t];

        //xor with the data and done
        inp[x] = (inp[x] ^ k);

        //poinformuj o postpie
        if( x & 0x0000FFFF )	//ogranicz czsto aktualizacji informacji o postpie
        {
            Application->ProcessMessages();	//pozwl na przesuwanie okna itp.
        	frmMain->CGauge1->Progress = 100 * (float)x/(float)lSize;
            frmMain->Update();
        }
    }
    frmMain->CGauge1->Progress = 100;
}


//---------------------------------------------------------------------------
void __fastcall TfrmMain::btnOpenClick(TObject *Sender)
{
    btnOpen->Enabled = false;
    CGauge1->Progress = 0;
	if(OpenDialog1->Execute())
    {
    	FILE *pFileIn = fopen(OpenDialog1->FileName.c_str(), "rb");
        if(!pFileIn)
        {
        	Application->MessageBox("Failed to open file", frmMain->Caption.c_str(), MB_ICONEXCLAMATION);
            btnOpen->Enabled = true;
            return;
        }
	    // obtain file size.
        fseek (pFileIn , 0 , SEEK_END);
        lSize = ftell (pFileIn);
        rewind (pFileIn);

        // allocate memory to contain the whole file.
        char* buffer = (unsigned char*) malloc (lSize);
        if (buffer == NULL)
        {
            Application->MessageBox("Not enough memory to open file", frmMain->Caption.c_str(), MB_ICONEXCLAMATION);
            fclose(pFileIn);
            btnOpen->Enabled = true;
            return;
        }

        // copy the file into the buffer.
        fread (buffer,1,lSize, pFileIn);

        Crypt(buffer, lSize, PASSWORD);

        if(SaveDialog1->Execute())
        {
        	FILE *pFileOut = fopen(SaveDialog1->FileName.c_str(), "wb");	//file will be overwritten
            if(pFileOut)
            {
            	fwrite(buffer, lSize, 1, pFileOut);
            }
            else
                Application->MessageBox("Failed to create output file", frmMain->Caption.c_str(), MB_ICONEXCLAMATION);
			if(pFileOut) fclose (pFileOut);                
        }

        if(pFileIn) fclose (pFileIn);
        if(buffer) free (buffer);
    }
    btnOpen->Enabled = true;
}
//---------------------------------------------------------------------------
